# remirepo/Fedora spec file for php-zendframework-zend-uri
#
# Copyright (c) 2015-2019 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    bfc4a5b9a309711e968d7c72afae4ac50c650083
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-uri
%global php_home     %{_datadir}/php
%global library      Uri
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.7.1
Release:        2%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-pcre
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.4",
#        "zendframework/zend-coding-standard": "~1.0.0"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-autoloader(%{gh_owner}/zend-escaper)        >= 2.5   with php-autoloader(%{gh_owner}/zend-escaper)        < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-validator)      >= 2.10  with php-autoloader(%{gh_owner}/zend-validator)      < 3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
# remirepo:8
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-escaper)        <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-escaper)        >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)      >= 2.10
%global phpunit %{_bindir}/phpunit6
BuildRequires:  phpunit6 >= 6.5.8
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-escaper": "^2.5",
#        "zendframework/zend-validator": "^2.10"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-escaper)        >= 2.5   with php-autoloader(%{gh_owner}/zend-escaper)        < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-validator)      >= 2.10  with php-autoloader(%{gh_owner}/zend-validator)      < 3)
# remirepo:6
%else
Requires:       php-autoloader(%{gh_owner}/zend-escaper)        <  3
Requires:       php-autoloader(%{gh_owner}/zend-escaper)        >= 2.5
Requires:       php-autoloader(%{gh_owner}/zend-validator)      <  3
Requires:       php-autoloader(%{gh_owner}/zend-validator)      >= 2.10
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.5.2
Requires:       php-pcre
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Uri is a component that aids in manipulating and validating Uniform
Resource Identifiers (URIs). Zend\Uri exists primarily to service other
components, such as Zend\Http, but is also useful as a standalone utility.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Escaper/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72 php73 php74; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Tue Oct  8 2019 Remi Collet <remi@remirepo.net> - 2.7.1-1
- update to 2.7.1

* Thu Feb 28 2019 Remi Collet <remi@remirepo.net> - 2.7.0-1
- update to 2.7.0

* Wed Feb 27 2019 Remi Collet <remi@remirepo.net> - 2.6.2-1
- update to 2.6.2

* Wed May  2 2018 Remi Collet <remi@remirepo.net> - 2.6.1-2
- update to 2.6.1
- use range dependencies
- raise dependency on zend-validator 2.10
- switch to phpunit7

* Wed Apr 11 2018 Remi Collet <remi@remirepo.net> - 2.6.0-1
- update to 2.6.0
- raise dependency on PHP 5.6
- switch to phpunit6

* Thu Dec  7 2017 Remi Collet <remi@remirepo.net> - 2.5.2-4
- switch from zend-loader to fedora/autoloader

* Thu Feb 18 2016 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise dependency on PHP >= 5.5

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
